#include <QGuiApplication>
#include <QQmlApplicationEngine>
#include <QQmlContext>

#include "worker.h"

int main(int argc, char *argv[])
{
    QCoreApplication::setAttribute(Qt::AA_EnableHighDpiScaling);

    QGuiApplication app(argc, argv);

    Worker worker;

    QQmlApplicationEngine engine;
    engine.rootContext()->setContextProperty("calculations", &worker); // worker będzie używany w QML pod nazwą calculations

    const QUrl url(QStringLiteral("qrc:/main.qml"));
    QObject::connect(&engine, &QQmlApplicationEngine::objectCreated,
                     &app, [url](QObject *obj, const QUrl &objUrl) {
        if (!obj && url == objUrl)
            QCoreApplication::exit(-1);
    }, Qt::QueuedConnection);
    engine.load(url);

    return app.exec();
}
